<template>
  <b-card class="login card-elevated">
    <div class="text-center login__logo">
      <b-img :src="logo" alt="Conexa Saúde"/>
    </div>
    <hr class="login__divider">
    <b-alert :show="alertShow" variant="danger">
      {{ alertMessage }}
    </b-alert>
    <validation-observer ref="observer" v-slot="{ handleSubmit }">
      <b-form @submit.stop.prevent="handleSubmit(submitLogin)">
        <validation-provider name="E-mail" rules="required|email" v-slot="v">
          <b-form-group
            label="E-mail"
            label-for="login-email"
          >
            <b-form-input
              id="login-email"
              type="email"
              placeholder="joao@email.com"
              v-model="email"
              :state="getValidationState(v)"
              :disabled="loading"
              trim
            />
            <b-form-invalid-feedback>{{ v.errors[0] }}</b-form-invalid-feedback>
          </b-form-group>
        </validation-provider>
        <validation-provider name="Senha" rules="required|min:6" v-slot="v">
          <b-form-group
            label="Senha"
            label-for="login-password"
          >
            <b-form-input
              id="login-password"
              type="password"
              placeholder="Mínimo de 6 dígitos"
              v-model="password"
              :state="getValidationState(v)"
              :disabled="loading"
              trim
            />
            <b-form-invalid-feedback>{{ v.errors[0] }}</b-form-invalid-feedback>
          </b-form-group>
        </validation-provider>
        <hr class="login__divider">
        <b-button 
          class="submitButton"
          type="submit" 
          :variant="loading ? 'secondary' : 'primary'" 
          :disabled="loading"
          squared 
          block
        >
          <b-spinner 
            v-if="loading"
            variant="light"
            small
          />
          {{ loading ? 'Enviando informações' : 'Entrar'}}
        </b-button>
      </b-form>
    </validation-observer>
  </b-card>
</template>

<script>
import { mapActions } from "vuex";
import { ValidationProvider, ValidationObserver, extend } from "vee-validate";
import { required, email, min } from "vee-validate/dist/rules";

import logo from './../../assets/images/logo-conexa.svg'

extend('email', email)
extend('required', required)
extend('min', min)

export default {
  components: {
    ValidationProvider,
    ValidationObserver
  },

  methods: {
    ...mapActions('auth', ['signin']),
    getValidationState ({ dirty, validated, valid = null }) {
      return dirty || validated ? valid : null
    },

    async submitLogin() {
      this.loading = true

      const { email, password } = this
      const { success, message } = await this.signin({ email, password })

      this.loading = false

      if (success) {
        this.$router.push({ name: 'list' })
      } else {
        this.alertMessage = message

        setTimeout(() => {
          this.alertShow = true
        }, 100);
      }
    }
  },

  data() {
    return {
      logo,
      alertShow: false,
      alertMessage: 'Mensagem de erro',
      loading: false,
      email: '',
      password: ''
    }
  }
}
</script>

<style>

</style>